use reqwest::blocking::Response;

pub struct APITransaction<R = Response> {
    /// Query made to API.
    query: String, //TODO: enum
    /// Response struct from abstracted library
    _response: Option<R>
}

impl<R> APITransaction<R> {
    pub fn new(_response: Option<R>) -> Self {
        APITransaction {
            query: String::default(),
            _response
        }
    }
}

pub struct API {
    base_url: String,
    token: Option<String>,
    history: Vec<APITransaction>
}

impl API {

}